/*
 * Copyright 2003 Thomas KIEFFER <tomkif@hotmail.lu>
 * All rights reserved.
 *
 * Copyright 2003 CSRRT-LU (http://www.csrrt.org.lu)
 * All right reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Niels Provos.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */



/*
 *class use to set up the different path and file
 *used by the GUI
 */
 
class FileName 
{
	private static String confFile="/root/honeyd.conf";//config file used to write the honeyd configuration
	private static String fingerFile="/usr/share/nmap/nmap-os-fingerprints";//used to list the different personnality for the virtual hosts
	private static String execPath="/usr/local/bin/honeyd";//executable of honeyd
	
	
	public FileName(String cf, String ff, String exec)
	{
		confFile=cf;
		fingerFile=ff;
		execPath=exec;
	}
	
	public FileName()
	{
	}
	
	public void setExecPath(String f)
	{
		execPath=f;
	}
	
	public void setConfigFile(String f)
	{
		confFile=f;
	}
	
	public void setFingerFile(String f)
	{
		fingerFile=f;
	}
	
	public String getExecPath()
	{
		return execPath;
	}
	
	public String getConfigFile()
	{
		return confFile;
	}
	
	public String getFingerFile()
	{
		return fingerFile;
	}
	
}
