/*
 * Copyright 2003 Thomas KIEFFER <tomkif@hotmail.lu>
 * All rights reserved.
 *
 * Copyright 2003 CSRRT-LU (http://www.csrrt.org.lu)
 * All right reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Niels Provos.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 *
 *used to parse the fingerprint file 
 *and take all personnality name
 */


import java.io.*;
import java.util.*;

class ParseFingerprint 
{
	private String fileName;
	private Vector fingName;//list of fingerprint
	private int fingNumber=0;//number of fingerprint
	
	
	public ParseFingerprint(String fileName) 
	{
		this.fileName=fileName;
		fingName=new Vector();
		init();
	}
	
	private void init() 
	{
		try
		{
		
		BufferedReader br =new BufferedReader(new FileReader(fileName));
		StringBuffer sb;
		sb= new StringBuffer(br.readLine());
		while(sb!=null)
		{
			if(sb.indexOf("Fingerprint")!=-1)
			{
				fingName.add(sb.replace(0,12,"").toString());
				fingNumber++;
			}
			sb=new StringBuffer(br.readLine());
		}
		}
		catch(Exception e){}
	}
	
	public String getFingerPrint(int i)
	{
		if(i<fingName.size())
		{
			return (String) fingName.get(i);
		}
		
		return "";
	}
	
	public void setFileName(String fileName) 
	{
		this.fileName=fileName;
		init();
	}
	
	public String getFileName()
	{
		return fileName;
	}
	
	public int getNumber()
	{
		return this.fingNumber;
	}
	

	
}
